# ***RigUIscript generated by Bone Layers Addon***

__author__ = "Oliver Simonnet (Rig / Model)"
__version__ = "1.2.2"

import bpy

blm_rig_id = "bj8to4tqgqfu"

class BLOP_PT_riguilayers(bpy.types.Panel):
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = 'Rig UI'
    bl_label = "Rig Layers"
    bl_idname = "BLOP_PT_riguilayers"

    @classmethod
    def poll(self, context):
        try:
            return (context.active_object.data.get("blm_rig_id") == blm_rig_id)
        except (AttributeError, KeyError, TypeError):
            return False

    def draw(self, context):
        layout = self.layout
        col = layout.column()

        row = col.row()
        row.prop(context.active_object.data,'layers', index=7, toggle=True, text='ROOT')

        row = col.row()
        row.prop(context.active_object.data,'layers', index=8, toggle=True, text='HEAD_TRACK')
        row.prop(context.active_object.data,'layers', index=9, toggle=True, text='TORSO')
        row.prop(context.active_object.data,'layers', index=10, toggle=True, text='TORSO_TWEAK')
        
        row = col.row()    
        row.prop(context.active_object.data,'layers', index=15, toggle=True, text='HANDS')
        row = col.row() 
        row.prop(context.active_object.data,'layers', index=16, toggle=True, text='HANDS_TWEAK')

        row = col.row()
        row.prop(context.active_object.data,'layers', index=12, toggle=True, text='R_ARM_FK')
        row.prop(context.active_object.data,'layers', index=11, toggle=True, text='L_ARM_FK')

        row = col.row()
        row.prop(context.active_object.data,'layers', index=14, toggle=True, text='R_ARM_IK')
        row.prop(context.active_object.data,'layers', index=13, toggle=True, text='L_ARM_IK')

        row = col.row()
        row.prop(context.active_object.data,'layers', index=25, toggle=True, text='R_ARM_SOCKET')
        row.prop(context.active_object.data,'layers', index=24, toggle=True, text='L_ARM_SOCKET')


        row = col.row()
        row.prop(context.active_object.data,'layers', index=17, toggle=True, text='HIPS_SOCKET')

        row = col.row()
        row.prop(context.active_object.data,'layers', index=19, toggle=True, text='R_LEG_IK')
        row.prop(context.active_object.data,'layers', index=18, toggle=True, text='L_LEG_IK')

        row = col.row()
        row.prop(context.active_object.data,'layers', index=21, toggle=True, text='R_LEG_FK')
        row.prop(context.active_object.data,'layers', index=20, toggle=True, text='L_LEG_FK')
        
        row = col.row()
        row.prop(context.active_object.data,'layers', index=23, toggle=True, text='R_LEG_SOCKET')
        row.prop(context.active_object.data,'layers', index=22, toggle=True, text='L_LEG_SOCKET')


class BLOP_PT_customproperties(bpy.types.Panel):
    """Creates a Rig Properties Panel (Pose Bone Custom Properties)"""
    bl_category = "Rig UI"
    bl_label = "Rig Properties"
    bl_idname = "BLOP_PT_customproperties"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_options = {'DEFAULT_CLOSED'}

    @classmethod
    def poll(self, context):
        if context.mode != 'POSE':
            return False

        try:
            return (context.active_object.type == 'ARMATURE')
        except (TypeError):
            return False

    def draw(self, context):
        layout = self.layout
        pose_bones = context.active_object.pose.bones
        try:
            selected_bones = [bone.name for bone in context.selected_pose_bones]
            selected_bones += [context.active_pose_bone.name]
        except (AttributeError, TypeError):
            return

        def assign_props(row, val, key):
            row.property = key
            row.data_path = "active_pose_bone"
            try:
                row.value = str(val)
            except:
                pass
        active_pose_bone = context.active_pose_bone

        rna_properties = {
            prop.identifier for prop in bpy.types.PoseBone.bl_rna.properties
            if prop.is_runtime
        }
    # Iterate through selected bones add each prop property of each bone to the panel.

        for bone in context.selected_pose_bones:
            if len(bone.keys()) > 1:
                box = layout.box()
            for key in sorted(bone.keys()):
                if key != '_RNA_UI' and key not in rna_properties:
                    val = bone.get(key, "value")
                    row = box.row()
                    split = row.split(align=True, factor=0.7)
                    row = split.row(align=True)
                    row.label(text=key, translate=False)
                    row = split.row(align=True)
                    row.prop(bone, f'["{key}"]', text = "", slider=True)


classes = (BLOP_PT_riguilayers, BLOP_PT_customproperties, )

register, unregister = bpy.utils.register_classes_factory(classes)

if __name__ == "__main__":
    register()